const { Schema, model } = require('mongoose')

const stats = new Schema({
  goals: {
    type: Number,
    default: 0,
  },
  assists: {
    type: Number,
    default: 0,
  },
  saves: {
    type: Number,
    default: 0,
  },
  shots: {
    type: Number,
    default: 0,
  },
  demos: {
    type: Number,
    default: 0,
  },
})

const players = new Schema({
  name: {
    type: String,
    required: true,
  },
  account: {
    type: String,
    required: true,
  },
})

const rosters = new Schema({
  name: {
    type: String,
    required: true,
  },
  logo: {
    type: String,
    required: true,
  },
  players: {
    type: [players],
  },
  stats: {
    type: stats,
  }
})

const Roster = model('Rosters', rosters)

module.exports = Roster