const { v4 } = require('uuid')
const crud = require('./crud')

const connections = {}

const subscribe = (ws, tid, type) => {
  const id = v4()
  connections[id] = {
    connection: ws,
    tid,
    type,
  }

  ws.send(JSON.stringify({
    event: 'info',
    data: 'Welcome to APL Nuke v1.1.0!',
  }))

  sendInitial(id)

  ws.on('close', () => {
    delete connections[id]
  })
}

const recvUpdate = async (channel, data) => {
  Object.keys(connections).forEach((k) => {
    sendInitial(k)
  })
}

const sendInitial = async (id) => {
  try {
    const c = connections[id]
    if (c.type === 'stream') {
      const stream = await crud['streams'].getById(c.tid)
      c.connection.send(JSON.stringify({
        event: 'streams:read',
        data: stream,
      }))
    } else if (c.type === 'bracket') {
      const bracket = await crud['brackets'].getById(c.tid)
      c.connection.send(JSON.stringify({
        event: 'brackets:read',
        data: bracket,
      }))
    }
  } catch (e) {
    console.warn(e)
  }
}

module.exports = {
  subscribe,
  recvUpdate,
}